import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

public class Automat<A, S> extends HashMap<Pair<A,S>,S>{
  Iterator<A> input;
  S state;
  S initialState;
  Set<S> terminalStates;

  public Automat(S initialState, Set<S> terminalStates) {
    this.initialState = initialState;
    this.terminalStates = terminalStates;
  }
  void initialize(Iterator<A> input) {
    this.input=input;
    state=initialState;
  }
  boolean step(){
    //TODO
    return false;
  }
  boolean run() {
    //TODO
    return false;
  }
  static Automat<Integer,String> getExample(){
    var s0 = "s_0";
    var s1 = "s_1";
    var s2 = "s_2";
    var s3 = "s_3";
    var a1 = new Automat<Integer, String>(s0, Set.of(s3));
    a1.put(new Pair<>(1, s0), s0);
    a1.put(new Pair<>(0, s0), s1);
    a1.put(new Pair<>(1, s1), s0);
    a1.put(new Pair<>(0, s1), s2);
    a1.put(new Pair<>(0, s2), s2);
    a1.put(new Pair<>(1, s2), s3);
    a1.put(new Pair<>(0, s3), s3);
    a1.put(new Pair<>(1, s3), s3);
    return a1;
  }    
}